﻿/*
    Program demonstrující práci s delegátem.
*/

using System;

namespace Delegate1
{
    delegate int ModifyOperationDelegate(int x);

    class Program
    {
        static public int[] ModifyArray(int[] a, ModifyOperationDelegate f)
        {
            int[] result = new int[a.Length];

            for (int i = 0; i < a.Length; i++)
                result[i] = f(a[i]);

            return result;
        }

        static public int DoubleValues(int x)
        {
            return 2 * x;
        }

        static public int SquareValues(int x)
        {
            return x * x;
        }

        static void WriteArray(string text, int[] a)
        {
            Console.WriteLine(text + ": ");
            for (int i = 0; i < a.Length - 1; i++)
                Console.Write("{0,3}", a[i]);
            Console.WriteLine("{0,3}", a[a.Length - 1]);
        }

        static void Main(string[] args)
        {
            int[] array = { 1, 2, 3, 4, 5 };
            int[] modArray;

            ModifyOperationDelegate operation = DoubleValues;

            WriteArray("Původní pole", array);

            modArray = ModifyArray(array, operation);
            WriteArray("Dvojnásobky prvků", modArray);

            modArray = ModifyArray(array, SquareValues);
            WriteArray("Druhé mocniny prvků", modArray);
        }
    }
}

