﻿/*
    Program demonstrující práci s generickým delegátem a lambda výrazy.
*/

using System;

namespace Delegate4
{
    class Program
    {
        static public int[] ModifyArray(int[] a, Func<int, int> f)
        {
            int[] result = new int[a.Length];

            for (int i = 0; i < a.Length; i++)
                result[i] = f(a[i]);

            return result;
        }

        static void WriteArray(string text, int[] a)
        {
            Console.WriteLine(text + ": ");
            for (int i = 0; i < a.Length - 1; i++)
                Console.Write("{0,3}", a[i]);
            Console.WriteLine("{0,3}", a[a.Length - 1]);
        }

        static void Main(string[] args)
        {
            int[] array = { 1, 2, 3, 4, 5 };
            int[] modArray;

            Func<int, int> DoubleLambda = x => 2 * x;
            Func<int, int> SquareLambda = x => x * x;

            WriteArray("Původní pole", array);

            modArray = ModifyArray(array, DoubleLambda);
            WriteArray("Dvojnásobky prvků", modArray);

            modArray = ModifyArray(array, SquareLambda);
            WriteArray("Druhé mocniny prvků", modArray);
        }
    }
}
