﻿/*
    Program demonstrující událost a její obsluhu.
*/

using System;

namespace EventDemo
{
    class EventArgsStr : EventArgs
    {
        public string Message { get; set; }
    }

    class EventClass
    {
        public event EventHandler<EventArgsStr> MyEvent;

        public void Method(string s)
        {
            EventArgsStr e = new EventArgsStr();

            Console.WriteLine("Metoda spouští událost");
            e.Message = s;
            OnMyEvent(e);
        }

        protected virtual void OnMyEvent(EventArgsStr e)
        {
            EventHandler<EventArgsStr> handler = MyEvent; 

            if (handler != null)
            {
                handler(this, e);
            }
        }

    }

    class Program
    {
        static void Main(string[] args)
        {
            EventClass obj = new EventClass();

            obj.MyEvent += MyHandler;
            obj.Method("Hello");
        }

        static void MyHandler(object sender, EventArgsStr e)
        {
            Console.WriteLine("Obsluha události:");
            Console.WriteLine("Vydavetel: " + sender.ToString());
            Console.WriteLine("Předaná zpráva je: " + e.Message);
        }
    }
}

