﻿/*
    Program ukazující zachycení výjimky.
*/

using System;

namespace Exception
{
    class Square
    {
        public int Side { get; set; }

        public Square(int initialSide)
        {
            Side = initialSide;
        }

        public int GetArea()
        {
            return Side * Side;
        }

        public int GetPerimeter()
        {
            return 4 * Side;
        }
    }

    class Program
    {
        static void Main(string[] args)
        {
            string sideStr;
            int sideNum = 0;
            bool inputOK = false;

            while (!inputOK)
            {
                Console.Write("Zadej velikost strany v cm: ");
                sideStr = Console.ReadLine();
                try
                {
                    sideNum = Convert.ToInt32(sideStr);
                    inputOK = true;
                }
                catch (FormatException ex)
                {
                    Console.WriteLine("Zadaná hodnota není celé číslo");
                    Console.WriteLine("Nastala výjimka: " + ex.Message);
                    Console.WriteLine();
                }
            }

            Square sq = new Square(sideNum);
            Console.WriteLine("Obvod čtverce o délce strany {0} cm je {1} cm",
                sideNum, sq.GetPerimeter());
            Console.WriteLine("Obsah čtverce o délce strany {0} cm je {1} cm čtverečných",
                sideNum, sq.GetArea());
        }
    }
}

