﻿/*
    Program ukazující použití lokální funkce.
*/

using System;

namespace QuickSort
{
    class Program
    {
        static void InitArray(int[] a)
        {
            Random rand = new Random();

            for (int i = 0; i < a.Length; i++)
                a[i] = rand.Next(100);
        }

        static void WriteArray(int[] a)
        {
            for (int i = 0; i < a.Length-1; i++)
                Console.Write("{0,4}", a[i]);
            Console.WriteLine("{0,3}", a[a.Length - 1]);
        }

        static void QuickSort(int[] a)
        {
            void QSort(int l, int r)
            {
                int i, j, x, y;

                i = l; j = r;
                x = a[(l + r) / 2];
                do
                {
                    while (a[i] < x) i++;
                    while (x < a[j]) j--;
                    if (i <= j)
                    {
                        y = a[i]; a[i] = a[j]; a[j] = y;
                        i++; j--;
                    }
                }
                while (i <= j);
                if (l < j) QSort(l, j);
                if (i < r) QSort(i, r);
            }

            QSort(0, a.Length - 1);
        }

        static void Main(string[] args)
        {
            int[] a = new int[10];

            InitArray(a);
            Console.WriteLine("Neseřazená posloupnost:");
            WriteArray(a);
            Console.WriteLine();

            QuickSort(a);
            Console.WriteLine("Seřazená posloupnost:");
            WriteArray(a);

        }
    }
}

